#define SAVE_SCREEN //restore screen after program end
#define USE_GRAY_PATCH //use grayscale patch
#define OPTIMIZE_ROM_CALLS //Use ROM Call Optimization

#include <tigcclib.h> //necessary for the nostub stuff

#include "fatdata.h" //it's where i put my picture data, name it whatever you want
int _ti89; //needed to produce ti89 code
unsigned char len,val,counter = 0;
unsigned char *source;
unsigned char *pic1;
unsigned char *pic2;
unsigned char *dest;
unsigned int size;
unsigned int i;
short x;

void RLE_Decompression(void) {
if (!GrayOn ()) return; //if grayscale is on it quits
for (i=0;i<2;i++) {
if (i==0) { source = pic1; dest = ((unsigned char*)GetPlane(0)) + (TI89?0:425);}
else { source = pic2; dest = ((unsigned char*)GetPlane(1)) + (TI89?0:425);}
size = LCD_WIDTH*LCD_HEIGHT/8;
while (size) {
if (*source == 0x91) { source++; val = *source++; len = *source++;
while (len) { *dest++ = val; len--; size--; counter++;
if (counter == 20) { dest+=10; counter=0;}
}
}
else { *dest++ = *source++; size--; counter++;
if (counter == 20) { dest+=10; counter=0;}
}
}
}
}

//Now to use the code:

void _main(void) {
for(x=0;x<50;x++) {
pic1 = Fire1;
pic2 = Fire2;
RLE_Decompression();
GrayMode(GRAY_OFF); //so that no errors occur
pic1 = Fire3;
pic2 = Fire4;
RLE_Decompression();
GrayMode(GRAY_OFF);} //so that no errors occur
return;} //quits for good

